package com.zipcodewilmington.productmanager;

import org.junit.Assert;
import org.junit.Test;

import java.lang.reflect.Array;
import java.util.ArrayList;



public class InventoryTest {

    @Test
    public void testCalcInventoryValue() {
        //Given
        Inventory newInv = new Inventory();
        ArrayList<Double> values = new ArrayList<Double>();
        values.add(5.15);
        values.add(3.42);
        values.add(18.77);
        values.add(12.20);
        double expected = 39.54;


        //When
        double actual = newInv.calcInventoryValue(values);

        //Then
        Assert.assertEquals(expected, actual, 0.01);
    }

    @Test
    public void testGetProductList() {
        //Given
        Product product = new Product(6.00, 10);
        Product product2 = new Product(8.00, 12);
        Inventory newInv = new Inventory();
        ArrayList<Product> expected = Product.getProductList();


        //When
        ArrayList<Product> actual = newInv.getProductList();

        //Then
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void testGetListOfValues() {
        //Given
        Product product = new Product(6.00, 10);
        Product product2 = new Product(8.00, 12);
        Inventory newInventory = new Inventory();
        ArrayList<Double> expected = new ArrayList<Double>();
        expected.add(60.00);
        expected.add(96.00);


        //When
        ArrayList<Double> actual = new ArrayList<Double>(newInventory.getListOfValues());

        //Then
        Assert.assertEquals(expected, actual);
    }


    @Test
    public void testGetInvValue() {
        //Given
        Product product = new Product(6.00, 10);
        Product product2 = new Product(8.00, 12);
        Inventory newInventory = new Inventory();
        double expected = 156.00;


        //When
        double actual = newInventory.getInventoryValue();

        //Then
        Assert.assertEquals(expected, actual, 0.01);
    }
}
