package com.zipcodewilmington.productmanager;
import org.junit.Assert;
import org.junit.Test;

import java.util.ArrayList;

/**
 * Created by leon on 1/10/18.
 */
public class ProductTest {

    @Test
    public void testGetValueGetProductList() {
        //Given
        Product product = new Product(6.00, 10);
        Product product2 = new Product(8.00, 12);
        ArrayList<Product> products = new ArrayList<Product>(Product.getProductList());
        double expected = 60.00;

        //When
        double actual = products.get(0).getValue();

        //Then
        Assert.assertEquals(expected, actual, 0.01);
    }

    @Test
    public void testProductConstructorPrice() {
    // Given
        double price = 6.00;
        int quantity = 10;
        double expected = price;

        //When
        Product product = new Product(price, quantity);
        double actual = product.getPrice();

        //Then
        Assert.assertEquals(expected, actual, 0.01);


    }

    @Test
    public void testProductConstructorQuantity() {
        // Given
        double price = 6.00;
        int quantity = 10;
        double expected = quantity;

        //When
        Product product = new Product(price, quantity);
        double actual = product.getQuantity();

        //Then
        Assert.assertEquals(expected, actual, 0.01);


    }

    @Test
    public void testSetGetPrice() {
        // Given
        double price = 6.00;
        int quantity = 10;
        double newPrice = 8.00;
        double expected = newPrice;

        //When
        Product product = new Product(price, quantity);
        product.setPrice(newPrice);
        double actual = product.getPrice();

        //Then
        Assert.assertEquals(expected, actual, 0.01);

    }

    @Test
    public void testSetGetQuantity() {
        // Given
        double price = 6.00;
        int quantity = 10;
        int newQuantity = 44;
        int expected = newQuantity;

        //When
        Product product = new Product(price, quantity);
        product.setQuantity(newQuantity);
        int actual = product.getQuantity();

        //Then
        Assert.assertEquals(expected, actual, 0.01);

    }

    @Test
    public void testGetValue() {
        // Given
        double price = 6.00;
        int quantity = 10;
        double expected = 60.00;

        //When
        Product product = new Product(price, quantity);
        double actual = product.getValue();;

        //Then
        Assert.assertEquals(expected, actual, 0.01);

    }

    @Test
    public void testGetId() {
        // Given
        double price = 6.00;
        int quantity = 10;
        long expected = 1;

        //When
        Product product = new Product(price, quantity);
        double actual = product.getId();;

        //Then
        Assert.assertEquals(expected, actual, 0.01);

    }


}